scala.reflect.api

# TypeTags

###
Related Doc: package api

#### trait TypeTags extends AnyRef

A `TypeTag[T]` encapsulates the runtime type representation of some type `T`. Like scala.reflect.Manifest, the prime use case of `TypeTag`s is to give access to erased types. However, `TypeTag`s should be considered to be a richer replacement of the pre-2.10 notion of a Manifest, that are, in addition, fully integrated with Scala reflection.

There exist three different types of `TypeTags`:

- scala.reflect.api.TypeTags#TypeTag.
  A full type descriptor of a Scala type. For example, a `TypeTag[List[String]]` contains all type information, in this case, of type `scala.List[String]`.
- scala.reflect.ClassTag.
  A partial type descriptor of a Scala type. For example, a `ClassTag[List[String]]` contains only the erased class type information, in this case, of type `scala.collection.immutable.List`. `ClassTag`s provide access only to the runtime class of a type. Analogous to scala.reflect.ClassManifest
- scala.reflect.api.TypeTags#WeakTypeTag.
  A type descriptor for abstract types (see description below).

Like Manifests, `TypeTag`s are always generated by the compiler, and can be obtained in three ways:

##### #1 Via the methods typeTag, classTag, or weakTypeTag

For example:

    import scala.reflect.runtime.universe._
    val tt = typeTag[Int]

    import scala.reflect._
    val ct = classTag[String]

Each of these methods constructs a `TypeTag[T]` or `ClassTag[T]` for the given type argument `T`.

##### #2 Using an implicit parameter of type `TypeTag[T]`, `ClassTag[T]`, or `WeakTypeTag[T]`

For example:

    import scala.reflect.runtime.universe._

    def paramInfo[T](x: T)(implicit tag: TypeTag[T]): Unit = {
      val targs = tag.tpe match { case TypeRef(_, _, args) => args }
      println(s"type of $x has type arguments $targs")
    }

    scala> paramInfo(42)
    type of 42 has type arguments List()

    scala> paramInfo(List(1, 2))
    type of List(1, 2) has type arguments List(Int)

##### #3 Context bound of a type parameter

...on methods or classes. The above example can be implemented as follows:

    import scala.reflect.runtime.universe._

    def paramInfo[T: TypeTag](x: T): Unit = {
      val targs = typeOf[T] match { case TypeRef(_, _, args) => args }
      println(s"type of $x has type arguments $targs")
    }

    scala> paramInfo(42)
    type of 42 has type arguments List()

    scala> paramInfo(List(1, 2))
    type of List(1, 2) has type arguments List(Int)

##### `WeakTypeTag`s

`WeakTypeTag[T]` generalizes `TypeTag[T]`. Unlike a regular `TypeTag`, components of its type representation can be references to type parameters or abstract types. However, `WeakTypeTag[T]` tries to be as concrete as possible, i.e. if type tags are available for the referenced type arguments or abstract types, they are used to embed the concrete types into the `WeakTypeTag[T]`.

Continuing the example above:

    def weakParamInfo[T](x: T)(implicit tag: WeakTypeTag[T]): Unit = {
      val targs = tag.tpe match { case TypeRef(_, _, args) => args }
      println(s"type of $x has type arguments $targs")
    }

    scala> def foo[T] = weakParamInfo(List[T]())
    foo: [T]=> Unit

    scala> foo[Int]
    type of List() has type arguments List(T)

##### TypeTags and Manifests

`TypeTag`s correspond loosely to the pre-2.10 notion of scala.reflect.Manifests. While scala.reflect.ClassTag corresponds to scala.reflect.ClassManifest and scala.reflect.api.TypeTags#TypeTag mostly corresponds to scala.reflect.Manifest, other pre-2.10 `Manifest` types do not have a direct correspondence with a 2.10 "`Tag`" type.

- scala.reflect.OptManifest is not supported.
  This is because `Tag`s can reify arbitrary types, so they are always available. -
- There is no equivalent for scala.reflect.AnyValManifest.
  Instead, one can compare their `Tag` with one of the base `Tag`s (defined in the corresponding companion objects) in order to find out whether or not it represents a primitive value class. Additionally, it's possible to simply use `<tag>.tpe.typeSymbol.isPrimitiveValueClass`.
- There are no replacement for factory methods defined in the `Manifest` companion objects.
  Instead, one could generate corresponding types using the reflection APIs provided by Java (for classes) and Scala (for types).
- Certain manifest operations(i.e., <:<, >:> and typeArguments) are not supported.
  Instead, one could use the reflection APIs provided by Java (for classes) and Scala (for types).

In Scala 2.10, scala.reflect.ClassManifests are deprecated, and it is planned to deprecate scala.reflect.Manifest in favor of `TypeTag`s and `ClassTag`s in an upcoming point release. Thus, it is advisable to migrate any `Manifest`-based APIs to use `Tag`s.

For more information about `TypeTag`s, see the Reflection Guide: TypeTags

Self Type
  Universe
Source
  TypeTags.scala
See also

  scala.reflect.ClassTag, scala.reflect.api.TypeTags#TypeTag, scala.reflect.api.TypeTags#WeakTypeTag

Linear Supertypes
AnyRef, Any
Known Subclasses
JavaUniverse, Universe, Universe
Type Hierarchy Learn more about scaladoc diagrams
Ordering

1. Grouped
2. Alphabetic
3. By inheritance

Inherited

1. TypeTags
2. AnyRef
3. Any

Implicitly

1. by any2stringadd
2. by StringFormat
3. by Ensuring
4. by ArrowAssoc

1. Hide All
2. Show all

Learn more about member selection
Visibility

1. Public
2. All

### Type Members

1. #### trait TypeTag[T] extends Universe.WeakTypeTag[T] with Equals with Serializable

   A `TypeTag` is a scala.reflect.api.TypeTags#WeakTypeTag with the additional static guarantee that all type references are concrete, i.e.

   A `TypeTag` is a scala.reflect.api.TypeTags#WeakTypeTag with the additional static guarantee that all type references are concrete, i.e. it does not contain any references to unresolved type parameters or abstract types.

   Annotations
     @implicitNotFound( "No TypeTag available for ${T}" )
   See also

     scala.reflect.api.TypeTags

2. #### trait WeakTypeTag[T] extends Equals with Serializable

   If an implicit value of type `WeakTypeTag[T]` is required, the compiler will create one, and the reflective representation of `T` can be accessed via the `tpe` field.

   If an implicit value of type `WeakTypeTag[T]` is required, the compiler will create one, and the reflective representation of `T` can be accessed via the `tpe` field. Components of `T` can be references to type parameters or abstract types. Note that `WeakTypeTag` makes an effort to be as concrete as possible, i.e. if `TypeTag`s are available for the referenced type arguments or abstract types, they are used to embed the concrete types into the WeakTypeTag. Otherwise the WeakTypeTag will contain a reference to an abstract type. This behavior can be useful, when one expects `T` to be perhaps be partially abstract, but requires special care to handle this case. However, if `T` is expected to be fully known, use scala.reflect.api.TypeTags#TypeTag instead, which statically guarantees this property.

   For more information about `TypeTag`s, see the Reflection Guide: TypeTags

   Annotations
     @implicitNotFound( "No WeakTypeTag available for ${T}" )
   See also

     scala.reflect.api.TypeTags

### Abstract Value Members

1. #### abstract def symbolOf[T](implicit arg0: Universe.WeakTypeTag[T]): Universe.TypeSymbol

   Type symbol of `x` as derived from a type tag.

### Concrete Value Members

1. #### final def !=(arg0: Any): Boolean

   Test two objects for inequality.

   Test two objects for inequality.

   returns

     `true` if !(this == that), false otherwise.

   Definition Classes
     AnyRef → Any

2. #### final def ##(): Int

   Equivalent to `x.hashCode` except for boxed numeric types and `null`.

   Equivalent to `x.hashCode` except for boxed numeric types and `null`. For numerics, it returns a hash value which is consistent with value equality: if two value type instances compare as true, then ## will produce the same hash value for each of them. For `null` returns a hashcode where `null.hashCode` throws a `NullPointerException`.

   returns

     a hash value consistent with ==

   Definition Classes
     AnyRef → Any

3. #### def +(other: String): String

   Implicit information
     This member is added by an implicit conversion from TypeTags to any2stringadd[TypeTags] performed by method any2stringadd in scala.Predef.
   Definition Classes
     any2stringadd

4. #### def ->[B](y: B): (TypeTags, B)

   Implicit information
     This member is added by an implicit conversion from TypeTags to ArrowAssoc[TypeTags] performed by method ArrowAssoc in scala.Predef.
   Definition Classes
     ArrowAssoc
   Annotations
     @inline()

5. #### final def ==(arg0: Any): Boolean

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   The expression `x == that` is equivalent to `if (x eq null) that eq null else x.equals(that)`.

   arg0

     the object to compare against this object for equality.

   returns

     `true` if the receiver object is equivalent to the argument; `false` otherwise.

   Definition Classes
     AnyRef → Any

6. #### object TypeTag extends Serializable

   Type tags corresponding to primitive types and constructor/extractor for WeakTypeTags.

7. #### object WeakTypeTag extends Serializable

   Type tags corresponding to primitive types and constructor/extractor for WeakTypeTags.

8. #### final def asInstanceOf[T0]: T0

   Cast the receiver object to be of type `T0`.

   Cast the receiver object to be of type `T0`.

   Note that the success of a cast at runtime is modulo Scala's erasure semantics. Therefore the expression `1.asInstanceOf[String]` will throw a `ClassCastException` at runtime, while the expression `List(1).asInstanceOf[List[String]]` will not. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the requested type.

   returns

     the receiver object.

   Definition Classes
     Any
   Exceptions thrown

     `ClassCastException` if the receiver object is not an instance of the erasure of type `T0`.

9. #### def clone(): AnyRef

   Create a copy of the receiver object.

   Create a copy of the receiver object.

   The default implementation of the `clone` method is platform dependent.

   returns

     a copy of the receiver object.

   Attributes
     protected[java.lang]
   Definition Classes
     AnyRef
   Annotations
     @throws( ... )
   Note

     not specified by SLS as a member of AnyRef

10. #### def ensuring(cond: (TypeTags) ⇒ Boolean, msg: ⇒ Any): TypeTags

    Implicit information
      This member is added by an implicit conversion from TypeTags to Ensuring[TypeTags] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

11. #### def ensuring(cond: (TypeTags) ⇒ Boolean): TypeTags

    Implicit information
      This member is added by an implicit conversion from TypeTags to Ensuring[TypeTags] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

12. #### def ensuring(cond: Boolean, msg: ⇒ Any): TypeTags

    Implicit information
      This member is added by an implicit conversion from TypeTags to Ensuring[TypeTags] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

13. #### def ensuring(cond: Boolean): TypeTags

    Implicit information
      This member is added by an implicit conversion from TypeTags to Ensuring[TypeTags] performed by method Ensuring in scala.Predef.
    Definition Classes
      Ensuring

14. #### final def eq(arg0: AnyRef): Boolean

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    Tests whether the argument (`arg0`) is a reference to the receiver object (`this`).

    The `eq` method implements an equivalence relation on non-null instances of `AnyRef`, and has three additional properties:

    - It is consistent: for any non-null instances `x` and `y` of type `AnyRef`, multiple invocations of `x.eq(y)` consistently returns `true` or consistently returns `false`.
    - For any non-null instance `x` of type `AnyRef`, `x.eq(null)` and `null.eq(x)` returns `false`.
    - `null.eq(null)` returns `true`.

    When overriding the `equals` or `hashCode` methods, it is important to ensure that their behavior is consistent with reference equality. Therefore, if two objects are references to each other (`o1 eq o2`), they should be equal to each other (`o1 == o2`) and they should hash to the same value (`o1.hashCode == o2.hashCode`).

    returns

      `true` if the argument is a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

15. #### def equals(arg0: Any): Boolean

    The equality method for reference types.

    The equality method for reference types. Default implementation delegates to `eq`.

    See also `equals` in scala.Any.

    returns

      `true` if the receiver object is equivalent to the argument; `false` otherwise.

    Definition Classes
      AnyRef → Any

16. #### def finalize(): Unit

    Called by the garbage collector on the receiver object when there are no more references to the object.

    Called by the garbage collector on the receiver object when there are no more references to the object.

    The details of when and if the `finalize` method is invoked, as well as the interaction between `finalize` and non-local returns and exceptions, are all platform dependent.

    Attributes
      protected[java.lang]
    Definition Classes
      AnyRef
    Annotations
      @throws( classOf[java.lang.Throwable] )
    Note

      not specified by SLS as a member of AnyRef

17. #### def formatted(fmtstr: String): String

    Implicit information
      This member is added by an implicit conversion from TypeTags to StringFormat[TypeTags] performed by method StringFormat in scala.Predef.
    Definition Classes
      StringFormat
    Annotations
      @inline()

18. #### final def getClass(): Class[_]

    A representation that corresponds to the dynamic class of the receiver object.

    A representation that corresponds to the dynamic class of the receiver object.

    The nature of the representation is platform dependent.

    returns

      a representation that corresponds to the dynamic class of the receiver object.

    Definition Classes
      AnyRef → Any
    Note

      not specified by SLS as a member of AnyRef

19. #### def hashCode(): Int

    The hashCode method for reference types.

    The hashCode method for reference types. See hashCode in scala.Any.

    returns

      the hash code value for this object.

    Definition Classes
      AnyRef → Any

20. #### final def isInstanceOf[T0]: Boolean

    Test whether the dynamic type of the receiver object is `T0`.

    Test whether the dynamic type of the receiver object is `T0`.

    Note that the result of the test is modulo Scala's erasure semantics. Therefore the expression `1.isInstanceOf[String]` will return `false`, while the expression `List(1).isInstanceOf[List[String]]` will return `true`. In the latter example, because the type argument is erased as part of compilation it is not possible to check whether the contents of the list are of the specified type.

    returns

      `true` if the receiver object is an instance of erasure of type `T0`; `false` otherwise.

    Definition Classes
      Any

21. #### final def ne(arg0: AnyRef): Boolean

    Equivalent to `!(this eq that)`.

    Equivalent to `!(this eq that)`.

    returns

      `true` if the argument is not a reference to the receiver object; `false` otherwise.

    Definition Classes
      AnyRef

22. #### final def notify(): Unit

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Wakes up a single thread that is waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

23. #### final def notifyAll(): Unit

    Wakes up all threads that are waiting on the receiver object's monitor.

    Wakes up all threads that are waiting on the receiver object's monitor.

    Definition Classes
      AnyRef
    Note

      not specified by SLS as a member of AnyRef

24. #### final def synchronized[T0](arg0: ⇒ T0): T0

    Definition Classes
      AnyRef

25. #### def toString(): String

    Creates a String representation of this object.

    Creates a String representation of this object. The default representation is platform dependent. On the java platform it is the concatenation of the class name, "@", and the object's hashcode in hexadecimal.

    returns

      a String representation of the object.

    Definition Classes
      AnyRef → Any

26. #### def typeOf[T](implicit ttag: Universe.TypeTag[T]): Universe.Type

    Shortcut for `implicitly[TypeTag[T]].tpe`

27. #### def typeTag[T](implicit ttag: Universe.TypeTag[T]): Universe.TypeTag[T]

    Shortcut for `implicitly[TypeTag[T]]`

28. #### final def wait(): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

29. #### final def wait(arg0: Long, arg1: Int): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

30. #### final def wait(arg0: Long): Unit

    Definition Classes
      AnyRef
    Annotations
      @throws( ... )

31. #### def weakTypeOf[T](implicit attag: Universe.WeakTypeTag[T]): Universe.Type

    Shortcut for `implicitly[WeakTypeTag[T]].tpe`

32. #### def weakTypeTag[T](implicit attag: Universe.WeakTypeTag[T]): Universe.WeakTypeTag[T]

    Shortcut for `implicitly[WeakTypeTag[T]]`

33. #### def →[B](y: B): (TypeTags, B)

    Implicit information
      This member is added by an implicit conversion from TypeTags to ArrowAssoc[TypeTags] performed by method ArrowAssoc in scala.Predef.
    Definition Classes
      ArrowAssoc

### Inherited from AnyRef

### Inherited from Any

### Inherited by implicit conversion any2stringadd from TypeTags to any2stringadd[TypeTags]

### Inherited by implicit conversion StringFormat from TypeTags to StringFormat[TypeTags]

### Inherited by implicit conversion Ensuring from TypeTags to Ensuring[TypeTags]

### Inherited by implicit conversion ArrowAssoc from TypeTags to ArrowAssoc[TypeTags]

### TypeTags

### Ungrouped